#include <stdio.h>
#include "picture.h"

#define INDRAW	1
#define OUTDRAW 0

#define MAXLEN	1024

enum DR_IDENT {
	DRAWING=0,	QUIT,		FILEI,
	FILEO,		UNDEL,		DELETE,		RESIZE,	
	TEXT,		MOVE,		COPY,		GROUPING,
	UNGROUP,	FRAMEBOXTYPE,	DASHBOXTYPE,	MAKEBOXTYPE,
	LINETYPE,	ARROWTYPE,	CIRCLETYPE,	CIRCSTTYPE,
	ROLLRIGHT,	ROLLLEFT,	ROLLUP,		ROLLDOWN,
	BUTTOMMAX,
};

#define	CRSUCCESS	0
#define	CRNONE		1
#define	CRFAILURE	-1


#define	hidebx(bp)		g_line(bp->x1,bp->y1,bp->x2+1,bp->y2+1,\
				2,del_gc); MakeGrid()
#define	hideobjbx(obj)		g_line(obj->box.x1-org_x,\
				obj->box.y1-org_y,obj->box.x2-org_x+1,\
				obj->box.y2-org_y+1,2,del_gc);\
				MakeGrid()
#define	hidegrpbx(grp)		g_line(grp->box.x1-org_x,\
				grp->box.y1-org_y,grp->box.x2-org_x+1,\
				grp->box.y2-org_y+1,2,del_gc);\
				MakeGrid()
#define	paintbx(x1,y1,x2,y2)	g_line(x1,y1,x2,y2,2,gc)

#define	dl_box(x1,y1,x2,y2)	g_line(x1,y1,x2,y2,1,del_gc)
#define	dr_box(x1,y1,x2,y2)	g_line(x1,y1,x2,y2,1,gc)
#define ds_box(x1,y1,x2,y2)	g_line(x1,y1,x2,y2,1,dash_gc)
#define dx_box(x1,y1,x2,y2)	g_line(x1,y1,x2,y2,1,xor_gc)

#define	dr_circle(X,Y,R)	g_circle(X,Y,R,R,0,gc)
#define	dl_circle(X,Y,R)	g_circle(X,Y,R,R,0,del_gc)
#define	dx_circle(X,Y,R)	g_circle(X,Y,R,R,0,xor_gc)

#define	dr_circst(X,Y,R)	g_circle(X,Y,R,R,1,gc)
#define	dl_circst(X,Y,R)	g_circle(X,Y,R,R,1,del_gc)

#define	dl_line(x1,y1,x2,y2)	g_line(x1,y1,x2,y2,0,del_gc)
#define	dr_line(x1,y1,x2,y2)	g_line(x1,y1,x2,y2,0,gc)
#define	dx_line(x1,y1,x2,y2)	g_line(x1,y1,x2,y2,0,xor_gc)

#define inbox(X,Y,BOX)	((BOX.x1<=X)&&(X<=BOX.x2)&&(BOX.y1<=Y)&&(Y<=BOX.y2))
#define	boxinbox(A,B)	((B.x1<=A.x1)&&(A.x2<=B.x2)&&(B.y1<=A.y1)&&(A.y2<=B.y2))

#define sel_box(x1,y1,x2,y2)	g_line(x1,y1,x2,y2,1,sel_gc)
#define sel_grpbx(grp)		g_line(	grp->box.x1-org_x,grp->box.y1-org_y,\
			grp->box.x2-org_x,grp->box.y2-org_y,1,sel_gc)
#define sel_objbx(obj)		g_line(	obj->box.x1-org_x,obj->box.y1-org_y,\
			obj->box.x2-org_x,obj->box.y2-org_y,1,sel_gc)

#define	global	

#ifdef MAIN_MODULE
global	SCR	scr;
global	int	grid;
global	int	oldgrid;
global	int	org_x,org_y;
global	unsigned int	drwidth,drheight;
global  int	modified,mode;
global	char	scr_filename[MAXLEN];
#else
extern SCR	scr;
extern int	grid;
extern int	oldgrid;
extern int	org_x,org_y;
extern	unsigned int	drwidth,drheight;
extern int	modified,mode;
extern char	scr_filename[];
#endif
